/* application.c generated by valac 0.42.3, the Vala compiler
 * generated from application.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2005, 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 * Copyright (C) 2018 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "seahorse-common.h"
#include "seahorse-gkr.h"
#include "seahorse-ssh.h"
#include "pgp/seahorse-pgp-backend.h"
#include "pkcs11/seahorse-pkcs11-backend.h"
#include "config.h"


#define SEAHORSE_TYPE_APPLICATION (seahorse_application_get_type ())
#define SEAHORSE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_APPLICATION, SeahorseApplication))
#define SEAHORSE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_APPLICATION, SeahorseApplicationClass))
#define SEAHORSE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_APPLICATION))
#define SEAHORSE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_APPLICATION))
#define SEAHORSE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_APPLICATION, SeahorseApplicationClass))

typedef struct _SeahorseApplication SeahorseApplication;
typedef struct _SeahorseApplicationClass SeahorseApplicationClass;
typedef struct _SeahorseApplicationPrivate SeahorseApplicationPrivate;

#define SEAHORSE_TYPE_SEARCH_PROVIDER (seahorse_search_provider_get_type ())
#define SEAHORSE_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProvider))
#define SEAHORSE_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProviderClass))
#define SEAHORSE_IS_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER))
#define SEAHORSE_IS_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_SEARCH_PROVIDER))
#define SEAHORSE_SEARCH_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProviderClass))

typedef struct _SeahorseSearchProvider SeahorseSearchProvider;
typedef struct _SeahorseSearchProviderClass SeahorseSearchProviderClass;
enum  {
	SEAHORSE_APPLICATION_0_PROPERTY,
	SEAHORSE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* seahorse_application_properties[SEAHORSE_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SEAHORSE_TYPE_KEY_MANAGER (seahorse_key_manager_get_type ())
#define SEAHORSE_KEY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManager))
#define SEAHORSE_KEY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManagerClass))
#define SEAHORSE_IS_KEY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_KEY_MANAGER))
#define SEAHORSE_IS_KEY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_KEY_MANAGER))
#define SEAHORSE_KEY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManagerClass))

typedef struct _SeahorseKeyManager SeahorseKeyManager;
typedef struct _SeahorseKeyManagerClass SeahorseKeyManagerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))

struct _SeahorseApplication {
	GtkApplication parent_instance;
	SeahorseApplicationPrivate * priv;
};

struct _SeahorseApplicationClass {
	GtkApplicationClass parent_class;
};

struct _SeahorseApplicationPrivate {
	SeahorseSearchProvider* search_provider;
	guint search_provider_dbus_id;
};


static gint SeahorseApplication_private_offset;
static gpointer seahorse_application_parent_class = NULL;
static gboolean seahorse_application_show_version;
static gboolean seahorse_application_show_version = FALSE;
static gboolean seahorse_application_no_window;
static gboolean seahorse_application_no_window = FALSE;

GType seahorse_application_get_type (void) G_GNUC_CONST;
GType seahorse_search_provider_get_type (void) G_GNUC_CONST;
guint seahorse_search_provider_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
#define SEAHORSE_APPLICATION_INACTIVITY_TIMEOUT (120 * 1000)
SeahorseApplication* seahorse_application_new (void);
SeahorseApplication* seahorse_application_construct (GType object_type);
SeahorseSearchProvider* seahorse_search_provider_new (GApplication* app);
SeahorseSearchProvider* seahorse_search_provider_construct (GType object_type,
                                                            GApplication* app);
static void seahorse_application_real_startup (GApplication* base);
static void seahorse_application_real_activate (GApplication* base);
SeahorseKeyManager* seahorse_key_manager_new (SeahorseApplication* app);
SeahorseKeyManager* seahorse_key_manager_construct (GType object_type,
                                                    SeahorseApplication* app);
GType seahorse_key_manager_get_type (void) G_GNUC_CONST;
static gboolean seahorse_application_real_local_command_line (GApplication* base,
                                                       gchar*** arguments,
                                                       gint* exit_status);
static gint seahorse_application_real_command_line (GApplication* base,
                                             GApplicationCommandLine* command_line);
static gboolean seahorse_application_real_dbus_register (GApplication* base,
                                                  GDBusConnection* connection,
                                                  const gchar* object_path,
                                                  GError** error);
static void seahorse_application_real_dbus_unregister (GApplication* base,
                                                GDBusConnection* connection,
                                                const gchar* object_path);
void seahorse_application_initialize_search (SeahorseApplication* self);
void seahorse_search_provider_load (SeahorseSearchProvider* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
void seahorse_search_provider_load_finish (SeahorseSearchProvider* self,
                                           GAsyncResult* _res_,
                                           GError** error);
static void seahorse_application_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GOptionEntry SEAHORSE_APPLICATION_local_options[2] = {{"version", 'v', 0, G_OPTION_ARG_NONE, &seahorse_application_show_version, N_ ("Version of this application"), NULL}, {NULL}};
static const GOptionEntry SEAHORSE_APPLICATION_options[2] = {{"no-window", (gchar) 0, 0, G_OPTION_ARG_NONE, &seahorse_application_no_window, N_ ("Don't display a window"), NULL}, {NULL}};

static inline gpointer
seahorse_application_get_instance_private (SeahorseApplication* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseApplication_private_offset);
}


SeahorseApplication*
seahorse_application_construct (GType object_type)
{
	SeahorseApplication * self = NULL;
	SeahorseSearchProvider* _tmp0_;
#line 31 "../src/application.vala"
	self = (SeahorseApplication*) g_object_new (object_type, "application-id", "org.gnome.seahorse.Application", "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
#line 35 "../src/application.vala"
	_tmp0_ = seahorse_search_provider_new ((GApplication*) self);
#line 35 "../src/application.vala"
	_g_object_unref0 (self->priv->search_provider);
#line 35 "../src/application.vala"
	self->priv->search_provider = _tmp0_;
#line 30 "../src/application.vala"
	return self;
#line 176 "application.c"
}


SeahorseApplication*
seahorse_application_new (void)
{
#line 30 "../src/application.vala"
	return seahorse_application_construct (SEAHORSE_TYPE_APPLICATION);
#line 185 "application.c"
}


static void
seahorse_application_real_startup (GApplication* base)
{
	SeahorseApplication * self;
#line 38 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 39 "../src/application.vala"
	G_APPLICATION_CLASS (seahorse_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 42 "../src/application.vala"
	seahorse_icons_init ();
#line 45 "../src/application.vala"
	seahorse_gkr_backend_initialize ();
#line 46 "../src/application.vala"
	seahorse_ssh_backend_initialize ();
#line 48 "../src/application.vala"
	seahorse_pgp_backend_initialize ();
#line 51 "../src/application.vala"
	seahorse_pkcs11_backend_initialize ();
#line 207 "application.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/application.vala"
	return self ? g_object_ref (self) : NULL;
#line 216 "application.c"
}


static void
seahorse_application_real_activate (GApplication* base)
{
	SeahorseApplication * self;
	GtkWindow* key_mgr = NULL;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp4_;
#line 55 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 56 "../src/application.vala"
	G_APPLICATION_CLASS (seahorse_application_parent_class)->activate ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 58 "../src/application.vala"
	_tmp0_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 58 "../src/application.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 58 "../src/application.vala"
	key_mgr = _tmp1_;
#line 60 "../src/application.vala"
	_tmp2_ = key_mgr;
#line 60 "../src/application.vala"
	if (_tmp2_ == NULL) {
#line 243 "application.c"
		SeahorseKeyManager* _tmp3_;
#line 61 "../src/application.vala"
		_tmp3_ = seahorse_key_manager_new (self);
#line 61 "../src/application.vala"
		g_object_ref_sink (_tmp3_);
#line 61 "../src/application.vala"
		_g_object_unref0 (key_mgr);
#line 61 "../src/application.vala"
		key_mgr = (GtkWindow*) _tmp3_;
#line 253 "application.c"
	}
#line 63 "../src/application.vala"
	_tmp4_ = key_mgr;
#line 63 "../src/application.vala"
	gtk_window_present (_tmp4_);
#line 55 "../src/application.vala"
	_g_object_unref0 (key_mgr);
#line 261 "application.c"
}


static gboolean
seahorse_application_real_local_command_line (GApplication* base,
                                              gchar*** arguments,
                                              gint* exit_status)
{
	SeahorseApplication * self;
	gint _vala_exit_status = 0;
	gboolean result = FALSE;
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	GOptionContext* _tmp2_;
	GOptionContext* _tmp3_;
	GOptionContext* _tmp4_;
	GOptionGroup* _tmp5_;
	gboolean _tmp10_;
	gint _tmp11_ = 0;
	gboolean _tmp12_;
	GError * _inner_error_ = NULL;
#line 72 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 73 "../src/application.vala"
	_tmp0_ = g_option_context_new (N_ ("- System Settings"));
#line 73 "../src/application.vala"
	context = _tmp0_;
#line 74 "../src/application.vala"
	_tmp1_ = context;
#line 74 "../src/application.vala"
	g_option_context_set_ignore_unknown_options (_tmp1_, TRUE);
#line 75 "../src/application.vala"
	_tmp2_ = context;
#line 75 "../src/application.vala"
	g_option_context_add_main_entries (_tmp2_, SEAHORSE_APPLICATION_local_options, GETTEXT_PACKAGE);
#line 76 "../src/application.vala"
	_tmp3_ = context;
#line 76 "../src/application.vala"
	g_option_context_set_translation_domain (_tmp3_, GETTEXT_PACKAGE);
#line 77 "../src/application.vala"
	_tmp4_ = context;
#line 77 "../src/application.vala"
	_tmp5_ = gtk_get_option_group (TRUE);
#line 77 "../src/application.vala"
	g_option_context_add_group (_tmp4_, _tmp5_);
#line 308 "application.c"
	{
		gchar** tmp = NULL;
		gint tmp_length1;
		gint _tmp_size_;
		GOptionContext* _tmp6_;
#line 80 "../src/application.vala"
		tmp = *arguments;
#line 80 "../src/application.vala"
		tmp_length1 = _vala_array_length (*arguments);
#line 80 "../src/application.vala"
		_tmp_size_ = tmp_length1;
#line 81 "../src/application.vala"
		_tmp6_ = context;
#line 81 "../src/application.vala"
		g_option_context_parse (_tmp6_, &tmp_length1, &tmp, &_inner_error_);
#line 81 "../src/application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 326 "application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 79 "../src/application.vala"
		e = _inner_error_;
#line 79 "../src/application.vala"
		_inner_error_ = NULL;
#line 83 "../src/application.vala"
		_tmp7_ = e;
#line 83 "../src/application.vala"
		_tmp8_ = _tmp7_->message;
#line 83 "../src/application.vala"
		g_printerr ("seahorse: %s\n", _tmp8_);
#line 84 "../src/application.vala"
		_vala_exit_status = 1;
#line 85 "../src/application.vala"
		result = TRUE;
#line 85 "../src/application.vala"
		_g_error_free0 (e);
#line 85 "../src/application.vala"
		_g_option_context_free0 (context);
#line 85 "../src/application.vala"
		if (exit_status) {
#line 85 "../src/application.vala"
			*exit_status = _vala_exit_status;
#line 358 "application.c"
		}
#line 85 "../src/application.vala"
		return result;
#line 362 "application.c"
	}
	__finally0:
#line 79 "../src/application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 367 "application.c"
		gboolean _tmp9_ = FALSE;
#line 79 "../src/application.vala"
		_g_option_context_free0 (context);
#line 79 "../src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 79 "../src/application.vala"
		g_clear_error (&_inner_error_);
#line 79 "../src/application.vala"
		return _tmp9_;
#line 377 "application.c"
	}
#line 88 "../src/application.vala"
	_tmp10_ = seahorse_application_show_version;
#line 88 "../src/application.vala"
	if (_tmp10_) {
#line 89 "../src/application.vala"
		g_print ("%s\n", PACKAGE_STRING);
#line 91 "../src/application.vala"
		g_print ("GNUPG: %s (%d.%d.%d)\n", GNUPG, GPG_MAJOR, GPG_MINOR, GPG_MICRO);
#line 93 "../src/application.vala"
		_vala_exit_status = 0;
#line 94 "../src/application.vala"
		result = TRUE;
#line 94 "../src/application.vala"
		_g_option_context_free0 (context);
#line 94 "../src/application.vala"
		if (exit_status) {
#line 94 "../src/application.vala"
			*exit_status = _vala_exit_status;
#line 397 "application.c"
		}
#line 94 "../src/application.vala"
		return result;
#line 401 "application.c"
	}
#line 97 "../src/application.vala"
	_tmp12_ = G_APPLICATION_CLASS (seahorse_application_parent_class)->local_command_line ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), arguments, &_tmp11_);
#line 97 "../src/application.vala"
	_vala_exit_status = _tmp11_;
#line 97 "../src/application.vala"
	result = _tmp12_;
#line 97 "../src/application.vala"
	_g_option_context_free0 (context);
#line 97 "../src/application.vala"
	if (exit_status) {
#line 97 "../src/application.vala"
		*exit_status = _vala_exit_status;
#line 415 "application.c"
	}
#line 97 "../src/application.vala"
	return result;
#line 419 "application.c"
}


static gint
seahorse_application_real_command_line (GApplication* base,
                                        GApplicationCommandLine* command_line)
{
	SeahorseApplication * self;
	gint result = 0;
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	GOptionContext* _tmp2_;
	GOptionContext* _tmp3_;
	gchar** arguments = NULL;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	gint arguments_length1;
	gint _arguments_size_;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
#line 106 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 106 "../src/application.vala"
	g_return_val_if_fail (command_line != NULL, 0);
#line 107 "../src/application.vala"
	_tmp0_ = g_option_context_new (N_ ("- System Settings"));
#line 107 "../src/application.vala"
	context = _tmp0_;
#line 108 "../src/application.vala"
	_tmp1_ = context;
#line 108 "../src/application.vala"
	g_option_context_set_ignore_unknown_options (_tmp1_, TRUE);
#line 109 "../src/application.vala"
	_tmp2_ = context;
#line 109 "../src/application.vala"
	g_option_context_add_main_entries (_tmp2_, SEAHORSE_APPLICATION_options, GETTEXT_PACKAGE);
#line 110 "../src/application.vala"
	_tmp3_ = context;
#line 110 "../src/application.vala"
	g_option_context_set_translation_domain (_tmp3_, GETTEXT_PACKAGE);
#line 112 "../src/application.vala"
	_tmp5_ = g_application_command_line_get_arguments (command_line, &_tmp4_);
#line 112 "../src/application.vala"
	arguments = _tmp5_;
#line 112 "../src/application.vala"
	arguments_length1 = _tmp4_;
#line 112 "../src/application.vala"
	_arguments_size_ = arguments_length1;
#line 469 "application.c"
	{
		gchar** tmp = NULL;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gint tmp_length1;
		gint _tmp_size_;
		GOptionContext* _tmp7_;
#line 114 "../src/application.vala"
		_tmp6_ = arguments;
#line 114 "../src/application.vala"
		_tmp6__length1 = arguments_length1;
#line 114 "../src/application.vala"
		tmp = _tmp6_;
#line 114 "../src/application.vala"
		tmp_length1 = _tmp6__length1;
#line 114 "../src/application.vala"
		_tmp_size_ = tmp_length1;
#line 115 "../src/application.vala"
		_tmp7_ = context;
#line 115 "../src/application.vala"
		g_option_context_parse (_tmp7_, &tmp_length1, &tmp, &_inner_error_);
#line 115 "../src/application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 493 "application.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 113 "../src/application.vala"
		e = _inner_error_;
#line 113 "../src/application.vala"
		_inner_error_ = NULL;
#line 117 "../src/application.vala"
		_tmp8_ = e;
#line 117 "../src/application.vala"
		_tmp9_ = _tmp8_->message;
#line 117 "../src/application.vala"
		g_printerr ("seahorse: %s\n", _tmp9_);
#line 118 "../src/application.vala"
		result = 1;
#line 118 "../src/application.vala"
		_g_error_free0 (e);
#line 118 "../src/application.vala"
		arguments = (_vala_array_free (arguments, arguments_length1, (GDestroyNotify) g_free), NULL);
#line 118 "../src/application.vala"
		_g_option_context_free0 (context);
#line 118 "../src/application.vala"
		return result;
#line 523 "application.c"
	}
	__finally1:
#line 113 "../src/application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 528 "application.c"
		gint _tmp10_ = -1;
#line 113 "../src/application.vala"
		arguments = (_vala_array_free (arguments, arguments_length1, (GDestroyNotify) g_free), NULL);
#line 113 "../src/application.vala"
		_g_option_context_free0 (context);
#line 113 "../src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 113 "../src/application.vala"
		g_clear_error (&_inner_error_);
#line 113 "../src/application.vala"
		return _tmp10_;
#line 540 "application.c"
	}
#line 121 "../src/application.vala"
	_tmp11_ = seahorse_application_no_window;
#line 121 "../src/application.vala"
	if (_tmp11_) {
#line 122 "../src/application.vala"
		g_application_hold ((GApplication*) self);
#line 123 "../src/application.vala"
		g_application_set_inactivity_timeout ((GApplication*) self, (guint) SEAHORSE_APPLICATION_INACTIVITY_TIMEOUT);
#line 124 "../src/application.vala"
		g_application_release ((GApplication*) self);
#line 125 "../src/application.vala"
		result = 0;
#line 125 "../src/application.vala"
		arguments = (_vala_array_free (arguments, arguments_length1, (GDestroyNotify) g_free), NULL);
#line 125 "../src/application.vala"
		_g_option_context_free0 (context);
#line 125 "../src/application.vala"
		return result;
#line 560 "application.c"
	}
#line 128 "../src/application.vala"
	g_application_activate ((GApplication*) self);
#line 129 "../src/application.vala"
	result = 0;
#line 129 "../src/application.vala"
	arguments = (_vala_array_free (arguments, arguments_length1, (GDestroyNotify) g_free), NULL);
#line 129 "../src/application.vala"
	_g_option_context_free0 (context);
#line 129 "../src/application.vala"
	return result;
#line 572 "application.c"
}


static gboolean
seahorse_application_real_dbus_register (GApplication* base,
                                         GDBusConnection* connection,
                                         const gchar* object_path,
                                         GError** error)
{
	SeahorseApplication * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint _tmp2_ = 0U;
	SeahorseSearchProvider* _tmp3_;
	guint _tmp4_;
	GError * _inner_error_ = NULL;
#line 132 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 132 "../src/application.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 132 "../src/application.vala"
	g_return_val_if_fail (object_path != NULL, FALSE);
#line 133 "../src/application.vala"
	_tmp0_ = G_APPLICATION_CLASS (seahorse_application_parent_class)->dbus_register ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), connection, object_path, &_inner_error_);
#line 133 "../src/application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 599 "application.c"
		gboolean _tmp1_ = FALSE;
#line 133 "../src/application.vala"
		g_propagate_error (error, _inner_error_);
#line 133 "../src/application.vala"
		return _tmp1_;
#line 605 "application.c"
	}
#line 133 "../src/application.vala"
	if (!_tmp0_) {
#line 134 "../src/application.vala"
		result = FALSE;
#line 134 "../src/application.vala"
		return result;
#line 613 "application.c"
	}
#line 136 "../src/application.vala"
	_tmp3_ = self->priv->search_provider;
#line 136 "../src/application.vala"
	_tmp4_ = seahorse_search_provider_register_object (_tmp3_, connection, object_path, &_inner_error_);
#line 136 "../src/application.vala"
	_tmp2_ = _tmp4_;
#line 136 "../src/application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 623 "application.c"
		gboolean _tmp5_ = FALSE;
#line 136 "../src/application.vala"
		g_propagate_error (error, _inner_error_);
#line 136 "../src/application.vala"
		return _tmp5_;
#line 629 "application.c"
	}
#line 136 "../src/application.vala"
	self->priv->search_provider_dbus_id = _tmp2_;
#line 137 "../src/application.vala"
	result = TRUE;
#line 137 "../src/application.vala"
	return result;
#line 637 "application.c"
}


static void
seahorse_application_real_dbus_unregister (GApplication* base,
                                           GDBusConnection* connection,
                                           const gchar* object_path)
{
	SeahorseApplication * self;
	guint _tmp0_;
#line 140 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 140 "../src/application.vala"
	g_return_if_fail (connection != NULL);
#line 140 "../src/application.vala"
	g_return_if_fail (object_path != NULL);
#line 141 "../src/application.vala"
	_tmp0_ = self->priv->search_provider_dbus_id;
#line 141 "../src/application.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 658 "application.c"
		guint _tmp1_;
#line 142 "../src/application.vala"
		_tmp1_ = self->priv->search_provider_dbus_id;
#line 142 "../src/application.vala"
		g_dbus_connection_unregister_object (connection, _tmp1_);
#line 143 "../src/application.vala"
		self->priv->search_provider_dbus_id = (guint) 0;
#line 666 "application.c"
	}
#line 146 "../src/application.vala"
	G_APPLICATION_CLASS (seahorse_application_parent_class)->dbus_unregister ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), connection, object_path);
#line 670 "application.c"
}


void
seahorse_application_initialize_search (SeahorseApplication* self)
{
	SeahorseSearchProvider* _tmp0_;
#line 149 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/application.vala"
	_tmp0_ = self->priv->search_provider;
#line 150 "../src/application.vala"
	seahorse_search_provider_load (_tmp0_, NULL, NULL);
#line 684 "application.c"
}


static void
seahorse_application_class_init (SeahorseApplicationClass * klass)
{
#line 24 "../src/application.vala"
	seahorse_application_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/application.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseApplication_private_offset);
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication *)) seahorse_application_real_startup;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication *)) seahorse_application_real_activate;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->local_command_line = (gboolean (*) (GApplication *, gchar***, gint*)) seahorse_application_real_local_command_line;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication *, GApplicationCommandLine*)) seahorse_application_real_command_line;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_register = (gboolean (*) (GApplication *, GDBusConnection*, const gchar*, GError**)) seahorse_application_real_dbus_register;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_unregister = (void (*) (GApplication *, GDBusConnection*, const gchar*)) seahorse_application_real_dbus_unregister;
#line 24 "../src/application.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_application_finalize;
#line 709 "application.c"
}


static void
seahorse_application_instance_init (SeahorseApplication * self)
{
#line 24 "../src/application.vala"
	self->priv = seahorse_application_get_instance_private (self);
#line 26 "../src/application.vala"
	self->priv->search_provider_dbus_id = (guint) 0;
#line 720 "application.c"
}


static void
seahorse_application_finalize (GObject * obj)
{
	SeahorseApplication * self;
#line 24 "../src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_APPLICATION, SeahorseApplication);
#line 25 "../src/application.vala"
	_g_object_unref0 (self->priv->search_provider);
#line 24 "../src/application.vala"
	G_OBJECT_CLASS (seahorse_application_parent_class)->finalize (obj);
#line 734 "application.c"
}


GType
seahorse_application_get_type (void)
{
	static volatile gsize seahorse_application_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_application_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseApplication), 0, (GInstanceInitFunc) seahorse_application_instance_init, NULL };
		GType seahorse_application_type_id;
		seahorse_application_type_id = g_type_register_static (gtk_application_get_type (), "SeahorseApplication", &g_define_type_info, 0);
		SeahorseApplication_private_offset = g_type_add_instance_private (seahorse_application_type_id, sizeof (SeahorseApplicationPrivate));
		g_once_init_leave (&seahorse_application_type_id__volatile, seahorse_application_type_id);
	}
	return seahorse_application_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



