/* actions.c generated by valac 0.42.3, the Vala compiler
 * generated from actions.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"


#define SEAHORSE_SSH_TYPE_ACTIONS (seahorse_ssh_actions_get_type ())
#define SEAHORSE_SSH_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_SSH_TYPE_ACTIONS, SeahorseSshActions))
#define SEAHORSE_SSH_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_SSH_TYPE_ACTIONS, SeahorseSshActionsClass))
#define SEAHORSE_SSH_IS_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_SSH_TYPE_ACTIONS))
#define SEAHORSE_SSH_IS_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_SSH_TYPE_ACTIONS))
#define SEAHORSE_SSH_ACTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_SSH_TYPE_ACTIONS, SeahorseSshActionsClass))

typedef struct _SeahorseSshActions SeahorseSshActions;
typedef struct _SeahorseSshActionsClass SeahorseSshActionsClass;
typedef struct _SeahorseSshActionsPrivate SeahorseSshActionsPrivate;
enum  {
	SEAHORSE_SSH_ACTIONS_0_PROPERTY,
	SEAHORSE_SSH_ACTIONS_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_actions_properties[SEAHORSE_SSH_ACTIONS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SEAHORSE_SSH_TYPE_KEY (seahorse_ssh_key_get_type ())
#define SEAHORSE_SSH_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey))
#define SEAHORSE_SSH_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_SSH_TYPE_KEY, SeahorseSshKeyClass))
#define SEAHORSE_SSH_IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_SSH_TYPE_KEY))
#define SEAHORSE_SSH_IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_SSH_TYPE_KEY))
#define SEAHORSE_SSH_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_SSH_TYPE_KEY, SeahorseSshKeyClass))

typedef struct _SeahorseSshKey SeahorseSshKey;
typedef struct _SeahorseSshKeyClass SeahorseSshKeyClass;

struct _SeahorseSshActions {
	SeahorseActions parent_instance;
	SeahorseSshActionsPrivate * priv;
};

struct _SeahorseSshActionsClass {
	SeahorseActionsClass parent_class;
};


static gpointer seahorse_ssh_actions_parent_class = NULL;
static SeahorseSshActions* seahorse_ssh_actions__instance;
static SeahorseSshActions* seahorse_ssh_actions__instance = NULL;

GType seahorse_ssh_actions_get_type (void) G_GNUC_CONST;
static void seahorse_ssh_actions_on_ssh_upload (SeahorseSshActions* self,
                                         GtkAction* action);
static void _seahorse_ssh_actions_on_ssh_upload_gtk_action_callback (GtkAction* action,
                                                              gpointer self);
#define SEAHORSE_SSH_ACTIONS_UI_DEFINITION "\n" \
"    <ui>\n" \
"      <menubar>\n" \
"        <placeholder name=\"RemoteMenu\">\n" \
"          <menu name=\"Remote\" action=\"remote-menu\">\n" \
"            <menuitem action=\"remote-ssh-upload\"/>\n" \
"          </menu>\n" \
"        </placeholder>\n" \
"      </menubar>\n" \
"      <popup name=\"ObjectPopup\">\n" \
"        <menuitem action=\"remote-ssh-upload\"/>\n" \
"      </popup>\n" \
"    </ui>"
static SeahorseSshActions* seahorse_ssh_actions_new (const gchar* name);
static SeahorseSshActions* seahorse_ssh_actions_construct (GType object_type,
                                                    const gchar* name);
SeahorseSshActions* seahorse_ssh_actions_instance (void);
GType seahorse_ssh_key_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void seahorse_ssh_upload_prompt (GList* keys,
                                 GtkWindow* parent);
static GObject * seahorse_ssh_actions_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void seahorse_ssh_actions_finalize (GObject * obj);

static const GtkActionEntry SEAHORSE_SSH_ACTIONS_KEYS_ACTIONS[1] = {{"remote-ssh-upload", NULL, N_ ("Configure Key for _Secure Shell…"), NULL, N_ ("Send public Secure Shell key to another machine, and enable logins usi" \
"ng that key."), (GCallback) _seahorse_ssh_actions_on_ssh_upload_gtk_action_callback}};

static void
_seahorse_ssh_actions_on_ssh_upload_gtk_action_callback (GtkAction* action,
                                                         gpointer self)
{
#line 25 "../ssh/actions.vala"
	seahorse_ssh_actions_on_ssh_upload ((SeahorseSshActions*) self, action);
#line 107 "actions.c"
}


static SeahorseSshActions*
seahorse_ssh_actions_construct (GType object_type,
                                const gchar* name)
{
	SeahorseSshActions * self = NULL;
#line 51 "../ssh/actions.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 52 "../ssh/actions.vala"
	self = (SeahorseSshActions*) seahorse_actions_construct (object_type, name);
#line 51 "../ssh/actions.vala"
	return self;
#line 122 "actions.c"
}


static SeahorseSshActions*
seahorse_ssh_actions_new (const gchar* name)
{
#line 51 "../ssh/actions.vala"
	return seahorse_ssh_actions_construct (SEAHORSE_SSH_TYPE_ACTIONS, name);
#line 131 "actions.c"
}


SeahorseSshActions*
seahorse_ssh_actions_instance (void)
{
	SeahorseSshActions* result = NULL;
	SeahorseSshActions* _tmp0_;
	SeahorseSshActions* _tmp2_;
#line 58 "../ssh/actions.vala"
	_tmp0_ = seahorse_ssh_actions__instance;
#line 58 "../ssh/actions.vala"
	if (_tmp0_ == NULL) {
#line 145 "actions.c"
		SeahorseSshActions* _tmp1_;
#line 59 "../ssh/actions.vala"
		_tmp1_ = seahorse_ssh_actions_new ("SshKey");
#line 59 "../ssh/actions.vala"
		_g_object_unref0 (seahorse_ssh_actions__instance);
#line 59 "../ssh/actions.vala"
		seahorse_ssh_actions__instance = _tmp1_;
#line 153 "actions.c"
	}
#line 62 "../ssh/actions.vala"
	_tmp2_ = seahorse_ssh_actions__instance;
#line 62 "../ssh/actions.vala"
	result = _tmp2_;
#line 62 "../ssh/actions.vala"
	return result;
#line 161 "actions.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 69 "../ssh/actions.vala"
	return self ? g_object_ref (self) : NULL;
#line 170 "actions.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 69 "../ssh/actions.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 179 "actions.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 69 "../ssh/actions.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 188 "actions.c"
}


static void
seahorse_ssh_actions_on_ssh_upload (SeahorseSshActions* self,
                                    GtkAction* action)
{
	GList* keys = NULL;
	SeahorseCatalog* _tmp0_;
	SeahorseCatalog* _tmp1_;
	SeahorseCatalog* _tmp2_;
	gboolean _tmp3_;
	GList* _tmp15_;
	GtkWindow* _tmp16_;
	GtkWindow* _tmp17_;
#line 65 "../ssh/actions.vala"
	g_return_if_fail (self != NULL);
#line 65 "../ssh/actions.vala"
	g_return_if_fail (action != NULL);
#line 66 "../ssh/actions.vala"
	keys = NULL;
#line 68 "../ssh/actions.vala"
	_tmp0_ = seahorse_actions_get_catalog ((SeahorseActions*) self);
#line 68 "../ssh/actions.vala"
	_tmp1_ = _tmp0_;
#line 68 "../ssh/actions.vala"
	_tmp2_ = _tmp1_;
#line 68 "../ssh/actions.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 68 "../ssh/actions.vala"
	_g_object_unref0 (_tmp2_);
#line 68 "../ssh/actions.vala"
	if (_tmp3_) {
#line 222 "actions.c"
		SeahorseCatalog* _tmp4_;
		SeahorseCatalog* _tmp5_;
		SeahorseCatalog* _tmp6_;
		GList* _tmp7_;
		GList* _tmp8_;
#line 69 "../ssh/actions.vala"
		_tmp4_ = seahorse_actions_get_catalog ((SeahorseActions*) self);
#line 69 "../ssh/actions.vala"
		_tmp5_ = _tmp4_;
#line 69 "../ssh/actions.vala"
		_tmp6_ = _tmp5_;
#line 69 "../ssh/actions.vala"
		_tmp7_ = seahorse_catalog_get_selected_objects (_tmp6_);
#line 69 "../ssh/actions.vala"
		_tmp8_ = _tmp7_;
#line 69 "../ssh/actions.vala"
		_g_object_unref0 (_tmp6_);
#line 240 "actions.c"
		{
			GList* el_collection = NULL;
			GList* el_it = NULL;
#line 69 "../ssh/actions.vala"
			el_collection = _tmp8_;
#line 69 "../ssh/actions.vala"
			for (el_it = el_collection; el_it != NULL; el_it = el_it->next) {
#line 248 "actions.c"
				GObject* _tmp9_;
				GObject* el = NULL;
#line 69 "../ssh/actions.vala"
				_tmp9_ = _g_object_ref0 ((GObject*) el_it->data);
#line 69 "../ssh/actions.vala"
				el = _tmp9_;
#line 255 "actions.c"
				{
					SeahorseSshKey* key = NULL;
					GObject* _tmp10_;
					SeahorseSshKey* _tmp11_;
					SeahorseSshKey* _tmp12_;
#line 70 "../ssh/actions.vala"
					_tmp10_ = el;
#line 70 "../ssh/actions.vala"
					_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, SEAHORSE_SSH_TYPE_KEY) ? ((SeahorseSshKey*) _tmp10_) : NULL);
#line 70 "../ssh/actions.vala"
					key = _tmp11_;
#line 71 "../ssh/actions.vala"
					_tmp12_ = key;
#line 71 "../ssh/actions.vala"
					if (_tmp12_ != NULL) {
#line 271 "actions.c"
						SeahorseSshKey* _tmp13_;
						SeahorseSshKey* _tmp14_;
#line 72 "../ssh/actions.vala"
						_tmp13_ = key;
#line 72 "../ssh/actions.vala"
						_tmp14_ = _g_object_ref0 (_tmp13_);
#line 72 "../ssh/actions.vala"
						keys = g_list_prepend (keys, _tmp14_);
#line 280 "actions.c"
					}
#line 69 "../ssh/actions.vala"
					_g_object_unref0 (key);
#line 69 "../ssh/actions.vala"
					_g_object_unref0 (el);
#line 286 "actions.c"
				}
			}
#line 69 "../ssh/actions.vala"
			(el_collection == NULL) ? NULL : (el_collection = (_g_list_free__g_object_unref0_ (el_collection), NULL));
#line 291 "actions.c"
		}
	}
#line 76 "../ssh/actions.vala"
	_tmp15_ = keys;
#line 76 "../ssh/actions.vala"
	_tmp16_ = seahorse_action_get_window (action);
#line 76 "../ssh/actions.vala"
	_tmp17_ = _tmp16_;
#line 76 "../ssh/actions.vala"
	seahorse_ssh_upload_prompt (_tmp15_, _tmp17_);
#line 76 "../ssh/actions.vala"
	_g_object_unref0 (_tmp17_);
#line 65 "../ssh/actions.vala"
	(keys == NULL) ? NULL : (keys = (_g_list_free__g_object_unref0_ (keys), NULL));
#line 306 "actions.c"
}


static GObject *
seahorse_ssh_actions_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseSshActions * self;
#line 45 "../ssh/actions.vala"
	parent_class = G_OBJECT_CLASS (seahorse_ssh_actions_parent_class);
#line 45 "../ssh/actions.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 45 "../ssh/actions.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_ACTIONS, SeahorseSshActions);
#line 46 "../ssh/actions.vala"
	gtk_action_group_set_translation_domain ((GtkActionGroup*) self, GETTEXT_PACKAGE);
#line 47 "../ssh/actions.vala"
	gtk_action_group_add_actions ((GtkActionGroup*) self, SEAHORSE_SSH_ACTIONS_KEYS_ACTIONS, (guint) G_N_ELEMENTS (SEAHORSE_SSH_ACTIONS_KEYS_ACTIONS), self);
#line 48 "../ssh/actions.vala"
	seahorse_actions_register_definition ((SeahorseActions*) self, SEAHORSE_SSH_ACTIONS_UI_DEFINITION);
#line 45 "../ssh/actions.vala"
	return obj;
#line 332 "actions.c"
}


static void
seahorse_ssh_actions_class_init (SeahorseSshActionsClass * klass)
{
#line 23 "../ssh/actions.vala"
	seahorse_ssh_actions_parent_class = g_type_class_peek_parent (klass);
#line 23 "../ssh/actions.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_ssh_actions_constructor;
#line 23 "../ssh/actions.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_actions_finalize;
#line 345 "actions.c"
}


static void
seahorse_ssh_actions_instance_init (SeahorseSshActions * self)
{
}


static void
seahorse_ssh_actions_finalize (GObject * obj)
{
	SeahorseSshActions * self;
#line 23 "../ssh/actions.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_ACTIONS, SeahorseSshActions);
#line 23 "../ssh/actions.vala"
	G_OBJECT_CLASS (seahorse_ssh_actions_parent_class)->finalize (obj);
#line 363 "actions.c"
}


GType
seahorse_ssh_actions_get_type (void)
{
	static volatile gsize seahorse_ssh_actions_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_ssh_actions_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshActionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_actions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshActions), 0, (GInstanceInitFunc) seahorse_ssh_actions_instance_init, NULL };
		GType seahorse_ssh_actions_type_id;
		seahorse_ssh_actions_type_id = g_type_register_static (SEAHORSE_TYPE_ACTIONS, "SeahorseSshActions", &g_define_type_info, 0);
		g_once_init_leave (&seahorse_ssh_actions_type_id__volatile, seahorse_ssh_actions_type_id);
	}
	return seahorse_ssh_actions_type_id__volatile;
}



